Attribute VB_Name = "modBrowse"
' Die meisten Funktionen entstammen ActiveVB (www.ActiveVB.de) oder
' dem API-Guide (www.allapi.net)

Option Explicit

' Typen
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lparam As Long
    iImage As Long
End Type

' API-Deklarationen
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

' sollte sich von selbst erklren
Public Function BrowseForFolder(CallerHWnd As Long)
    Dim IDList As Long
    Dim sPath As String
    Dim BI As BrowseInfo
    
    ' Startwerte setzen
    With BI
        .hwndOwner = CallerHWnd
        .lpszTitle = lstrcat("C:\", "")
        .ulFlags = 1
    End With
    
    IDList = SHBrowseForFolder(BI)
    
    ' Wert auslesen
    If IDList Then
        sPath = String(260, 0)
        SHGetPathFromIDList IDList, sPath
        CoTaskMemFree IDList
        
        BrowseForFolder = Left(sPath, InStr(sPath, Chr(0)) - 1)
    End If
End Function

' Zeigt ein "Datei ffnen"-Dialog an
Public Function BrowseForFile(CallerHWnd As Long, Path As String) As String
    Dim Filter As String
    
    ' Filter setzen
    Filter = "Excecutables" & Chr$(0) & "*.exe;*.com;*.bat" & Chr$(0) & "All Files" & Chr$(0) & "*.*" & Chr$(0)
    
    ' Dialog anzeigen
    BrowseForFile = BrowseForFileEx(CallerHWnd, Path, Filter)
End Function

' Zeigt ein "Datei ffnen"-Dialog an
Public Function BrowseForExec(CallerHWnd As Long, Path As String) As String
    ' Dialog anzeigen
    BrowseForExec = BrowseForFileEx(CallerHWnd, Path, "Excecutable" & Chr$(0) & "*.exe" & Chr$(0))
End Function

' Zeigt ein "Datei ffnen"-Dialog an
Private Function BrowseForFileEx(CallerHWnd As Long, Path As String, Filter As String) As String
    Dim F As OPENFILENAME
    
    ' Ein paar Einstellungen
    F.lStructSize = Len(F)
    F.hwndOwner = CallerHWnd
    F.hInstance = App.hInstance
    F.lpstrFilter = Filter
    F.lpstrFile = Space$(254)
    F.nMaxFile = 255
    F.lpstrFileTitle = Space$(254)
    F.nMaxFileTitle = 255
    F.lpstrInitialDir = IIf(Len(Path) > 0, Path, "C:\")
    F.lpstrTitle = "Select file"
    F.flags = &H1004
    
    ' Anzeigen und auswerten
    If GetOpenFileName(F) Then BrowseForFileEx = Left(F.lpstrFile, InStr(F.lpstrFile, Chr(0)) - 1) Else BrowseForFileEx = Path
End Function
