Attribute VB_Name = "modExecCMD"
' (c) 2004 - 2005 by Jochen Wierum

Option Explicit

' Aktiv ausgewhlter Zweig
Public ActiveT As clsTree

' Fhrt ein Kommando anhand des gesprochenen Textes aus
Public Sub ExecCMD(CMD As String)
    Dim i As Long
    
    On Error GoTo ErrOut
    
    ' Text zum debuggen ausgeben
    frmDebug.Add "Got " & Chr(34) & CMD & Chr(34)
    
    ' Sonderflle
    If CMD = cmdComputer.GetCmdName Then
        ' "Computer" wurde gesagt
        ' einen Befehl lang zuhren, wenn erlaubt
        If Not MayChangeRunning Then Exit Sub
        Running = True
        ChangeIcon 2
        Exit Sub
        
    ElseIf CMD = cmdUp.GetCmdName And Running Then
        ' "up" wurde gesagt
        ' In den obersten Zweig springen
        Set ActiveT = cmds
        Beep
        Exit Sub
    End If
    
    ' Wenn wir nicht zuhren, raus hier!
    If Not Running Then Exit Sub
    
    ' Haben wir ein Kommando im aktuellen Zweig aufgerufen?
    For i = 1 To ActiveT.GetCommandCount
        If LCase(ActiveT.GetCommand(i).GetCmdName) = CMD Then
            ' Command ausfhren
            ExecCMDEx ActiveT.GetCommand(i)
            Exit Sub
        End If
    Next i
    
    ' Wurde ein Unterzweig angesprochen?
    For i = 1 To ActiveT.GetSubTreeCount
        If LCase(ActiveT.GetSubTree(i).GetTreeName) = CMD Then
            ' Zweig setzen
            Set ActiveT = ActiveT.GetSubTree(i)
            Beep
            Exit Sub
        End If
    Next i
    
    Exit Sub
ErrOut:
    frmDebug.Add "Error " & Err.Description & " (" & Err.Number & ")"
    frmDebug.Visible = True
End Sub

Private Function ExecCMDEx(c As clsCommand) As Boolean
    Dim ok As Boolean
     
     ' Anhand des ersten Parameters wird entschieden, ob...
    Select Case CLng(c.GetParam(1))
    Case 0
        ok = Run(c) ' ... ein Programm gestartet wird
    Case 1
        ok = SendK(c) ' ... Tasten gesendet werden sollen
    Case 2
        ok = SendMSG(c) ' ... eine WindowMessage gesendet wird
    Case 3
        ok = SpecialFuncs(c) ' ... Spezialfunktion (siehe modFuncSpecial)
    Case 4
        ok = SayText(c) ' ... ein Text gesprochen wird
    End Select
    
    ' Wenn immer nur ein Kommando abgefangen werden soll, nicht weiter zuhren
    ' -> "stop listening", "admin"
    If OnlyOneCommand And MayChangeRunning Then
        OnlyOneCommand = True
        Running = False
        ChangeIcon 0
    End If
    
    ' Wenn nicht im Men geblieben werden soll, zurckspringen
    ' -> "hold"
    If Not HoldMenu Then
        Set ActiveT = cmds
    End If
    
    ' Fehler?
    If ok = False Then
        frmDebug.Add "Error! Command: " & c.GetCmdName & ", Tree: " & ActiveT.GetTreeName
        Say "Error!"
    Else
        ' Der 1. Parameter beschreibt die Reaktion des Programmes.
        Select Case CLng(c.GetParam(0))
        Case 0              ' Nothing
        Case 1: Beep        ' Beep
        Case 2: Say Sir & "."  ' Say "Sir"
        End Select
    End If
End Function
