Attribute VB_Name = "modFuncsSpecial"
' (c) 2004 - 2005 by Jochen Wierum

Option Explicit

' API-Funktionen
Private Declare Function ShellExecute Lib "shell32.dll" _
    Alias "ShellExecuteA" (ByVal hwnd As Long, _
    ByVal lpOperation As String, ByVal lpFile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long

Private Declare Function EnumChildWindows Lib "user32" ( _
    ByVal hWndParent As Long, ByVal lpEnumFunc As Long, _
    ByVal lparam As Long) As Long
    
Private Declare Function GetForegroundWindow Lib "user32" () As Long

Private Declare Function GetDlgCtrlID Lib "user32" ( _
    ByVal hwnd As Long) As Long
    
Private Declare Function PostMessage Lib "user32" Alias _
    "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, ByVal lparam As Long) As Long
    
Private Declare Function GetWindowText Lib "user32" Alias _
    "GetWindowTextA" (ByVal hwnd As Long, _
    ByVal lpString As String, ByVal cch As Long) As Long
    
Private Declare Function GetWindowTextLength Lib "user32" _
    Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long

' Konstanten, unter denen die Funktionen angesprochen werden
Public Const CMDSYSCOMPUTER = 0 ' - Zuhren!
Private Const CMDSYSADMIN = 1   ' - Einstellungen anzeigen
Private Const CMDSYSBEGIN_LISTENING = 2 ' - Dauerhaft zuhren
Private Const CMDSYSEXIT_LISTENING = 3  ' - Nur nach "computer" zuhren
Private Const CMDSYSQUIT = 4    ' - Beenden
Private Const CMDSYSHOLD = 5    ' - Im Men bleiben
Public Const CMDSYSUP = 6       ' - Falls im "Hold"-Modus, zurcknavigieren
Private Const CMDSYSINFORMATION = 7 ' - Aboutfenster
Private Const CMDSYSDEBUG = 8   ' - Debugfenster einblenden

Private Const CMDSFBUTTONOK = 10    ' - Buttonklick "OK"
Private Const CMDSFBUTTONCANCEL = 11 ' - "Cancel"
Private Const CMDSFBUTTONYES = 12   ' -  "Yes", "Ja"...
Private Const CMDSFBUTTONNO = 13    ' -  "No", "Nein"...
Private Const CMDSFBUTTONRETRY = 14 ' -  "Retry", "Widerholen"...
Private Const CMDSFBUTTONIGNORE = 15 ' - "Ignore", "Ignorieren"
Private Const CMDSFBUTTONABORT = 16 ' -  "Abort", "Abbrechen"

Private Const CMDSFSAYTIME = 17     ' - Sagt die Zeit

Private Buttons() As String     ' - Buttonbeschriftungen
Public AdminRunning As Boolean  ' - Wird das Adminfenster angezeigt?

Public cmdComputer As clsCommand ' - Sonderbfehel "Computer" (funktioniert immer)
Public cmdUp As clsCommand       ' - Sonderbefehl "Up" (funktioniert in jedem Zweig)

'Fllt eine Listbox mit allen mglichen SysCommands
Public Sub FillListWithSFuncs(Dest As ListBox)
    With Dest
        '.AddItem "'Computer'": .ItemData(.ListCount - 1) = CMDSFCOMPUTER
        .AddItem "'Admin'": .ItemData(.ListCount - 1) = CMDSYSADMIN
        .AddItem "'Begin listening'": .ItemData(.ListCount - 1) = CMDSYSBEGIN_LISTENING
        .AddItem "'Exit listening'": .ItemData(.ListCount - 1) = CMDSYSEXIT_LISTENING
        .AddItem "'Quit'": .ItemData(.ListCount - 1) = CMDSYSQUIT
        .AddItem "'Hold'": .ItemData(.ListCount - 1) = CMDSYSHOLD
        '.AddItem "'UP'": .ItemData(.ListCount - 1) = CMDSYSUP
        .AddItem "'information'": .ItemData(.ListCount - 1) = CMDSYSINFORMATION
        .AddItem "'Debug'": .ItemData(.ListCount - 1) = CMDSYSDEBUG
        
        .AddItem "Click the 'OK' button": .ItemData(.ListCount - 1) = CMDSFBUTTONOK
        .AddItem "Click the 'Cancel' button": .ItemData(.ListCount - 1) = CMDSFBUTTONCANCEL
        .AddItem "Click the 'Yes' button": .ItemData(.ListCount - 1) = CMDSFBUTTONYES
        .AddItem "Click the 'No' button": .ItemData(.ListCount - 1) = CMDSFBUTTONNO
        .AddItem "Click the 'Retry' button": .ItemData(.ListCount - 1) = CMDSFBUTTONRETRY
        .AddItem "Click the 'Ignore' button": .ItemData(.ListCount - 1) = CMDSFBUTTONIGNORE
        .AddItem "Click the 'Abort' button": .ItemData(.ListCount - 1) = CMDSFBUTTONABORT
        
        .AddItem "Say the Time": .ItemData(.ListCount - 1) = CMDSFSAYTIME
    End With
End Sub

'Startet eine Datei
Public Function StartFile(File As String, Params As String, ExecIn As String) As Boolean
    Dim E As Long
    
    E = ShellExecute(frmHidden.hwnd, "open", File, Params, ExecIn, 1)
    
    If E < 0 Or E > 32 Then StartFile = True
End Function

' Startet eine Datei anhand den Parameter eine Commandklasse
Public Function Run(c As clsCommand) As Boolean
    Run = StartFile(c.GetParam(2), c.GetParam(3), c.GetParam(4))
End Function

' Sendet Stings an die aktive Anwendung
Public Function SendK(c As clsCommand) As Boolean
    Dim lines() As String
    Dim i As Integer
    
    'Zeilen splitten
    lines = Split(c.GetParam(2), vbCrLf)
    
    'Zeilenweise senden (evtl. warten)
    For i = 0 To UBound(lines)
        SendKeys lines(i), c.GetParam(3)
    Next i
    
    SendK = True
End Function

' Spricht einen Text aus
Public Function SayText(c As clsCommand) As Boolean
    Say c.GetParam(2)
    SayText = True
End Function

' Ld die Buttonbeschriftungen
Public Function InitButtons()
    Dim b As clsSettings
    Dim i As Integer
    
    ' INI-Datei parsen
    Set b = New clsSettings
    b.InitialiseINI APath & "buttons.def", 524288
    
    'Alle speichern
    ReDim Buttons(b.GetSetting("buttons", "count", 1) - 1)
    For i = 0 To b.GetSetting("buttons", "count", 1) - 1
        Buttons(i) = LCase(b.GetSetting("buttons", CStr(i), ""))
    Next i
    
    Set b = Nothing
End Function

' Button drcken
Public Function PressButton(BNr As Integer)
    'Alle Fenster enumerieren
    EnumChildWindows GetForegroundWindow, AddressOf EnumAChild, BNr
End Function

Public Function EnumAChild(ByVal hwnd As Long, ByVal lparam As Long) As Boolean
    Dim lngButtonID As Long
    Dim lngLength As Long
    Dim strTitle As String
    Dim lngResult As Long
    Dim i As Long
    Dim temp() As String
    
    EnumAChild = True
    
    temp = Split(Buttons(lparam), ",")
    
    ' Fenstertitellnge (Beschriftung des Buttons) bestimmen
    lngLength = GetWindowTextLength(hwnd)
    If lngLength > 0 Then
        
        ' Den Titel lesen
        strTitle = String$(100, Chr(0))
        lngResult = GetWindowText(hwnd, strTitle, lngLength + 1)
        
        ' Auf den Unterstrich verzichten
        strTitle = Left$(strTitle, lngLength)
        strTitle = Replace(strTitle, "&", "")
        
        'Jedes Button prfen
        For i = 0 To UBound(temp)
            If LCase(strTitle) = temp(i) Then
                
                'Beschriftung stimmt berein
                lngButtonID = GetDlgCtrlID(hwnd)
                lngResult = PostMessage(GetForegroundWindow, &H111, lngButtonID, hwnd)
                
                'Enumerierung beenden
                If lngResult <> 0 Then
                    EnumAChild = False
                End If
                
                Exit Function
            End If
        Next i
    End If
End Function

' Die Zeit aussprechen
Public Function SayTime(t As Date) As String
    Dim min As String
    Dim d As String
    Dim daynr As String
    Dim mon As String
    
    ' Minute und Tag speichern
    min = Minute(t)
    daynr = Day(t)
    
    ' Endung anfgen
    If daynr > 10 And daynr < 14 Then
        daynr = daynr & "th"
    Else
        Select Case CLng(daynr) Mod 10
        Case 1:         daynr = daynr & "st"
        Case 2:         daynr = daynr & "nd"
        Case 3:         daynr = daynr & "rd"
        Case 4 To 9, 0: daynr = daynr & "th"
        End Select
    End If
    
    ' Monat, Tag und Sekunden
    min = min & " minute" & IIf(CLng(min) <> 1, "s", "")
    d = Choose(Weekday(t, vbMonday), "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday")
    mon = Choose(Month(t), "January", "February", "March", "April", "Mai", "June", "July", "August", "September", "October", "November", "December")
    
    ' Einen Satz daraus machen
    SayTime = "We have " & d & " the " & daynr & " " & mon & " " & Year(t) & ". " & _
        "It's " & Hour(t) & " o clock, and " & min & ". "
End Function

' Spezialfunktion ausfhren
Public Function SpecialFuncs(c As clsCommand) As Boolean
    ' Prfen, ob die Funktion wirklich ausgefhrt werden darf.
    If CLng(c.GetParam(1)) <> 3 Then Exit Function
    
    Dim oldRunning As Boolean
    
    SpecialFuncs = True
    
    Select Case CLng(c.GetParam(2))
    Case CMDSYSADMIN ' Admin
        ' Keine weiteren Eingaben abfangen
        oldRunning = Running
        MayChangeRunning = False
        Running = False
        HideIcon
        
        'Adminfenster zeigen und auf schlieen warten
        frmAdmin.Show
        AdminRunning = True
        Do Until Not AdminRunning
            DoEvents
        Loop
        
        ' Neuladen der Spracherkennung
        frmHidden.DSR.Deactivate
        Say "One moment please."
        frmHidden.DSR.GrammarFromFile APath & "grammar.dat"
        
        ' Commandclass erneut laden
        Set cmds = Nothing
        LoadCommandClass
        Set ActiveT = cmds
        frmHidden.DSR.Activate
        
        ' Alten Status wiederherstellen
        Running = oldRunning
        MayChangeRunning = True
        ShowIcon
        ChangeIcon IIf(Running, 2, 0)
        Say "I'm here!"
        
    ' Zuhren
    Case CMDSYSBEGIN_LISTENING
        OnlyOneCommand = False
        Say "I'm here, " & Sir & "."
    
    ' Nicht mehr zuhren
    Case CMDSYSEXIT_LISTENING
        OnlyOneCommand = True
        Say "Call me, if you need me, " & Sir & "."
    
    ' Programm beenden
    Case CMDSYSQUIT
        frmHidden.tmrUnload = True
    
    ' In den Mens bleiben
    Case CMDSYSHOLD
        HoldMenu = Not HoldMenu
        
        If HoldMenu Then
            Say "I will now stay in a menu!"
        Else
            Say "I will now jump back after each command!"
        End If
        
    ' About
    Case CMDSYSINFORMATION
        frmAbout.Show
        
    ' Ein Button
    Case CMDSFBUTTONOK To CMDSFBUTTONABORT
        PressButton CLng(c.GetParam(2)) - CMDSFBUTTONOK
    
    ' Die Uhrzeit sagen
    Case CMDSFSAYTIME
        Say SayTime(Now)
    
    ' Debugfenster anzeigen
    Case CMDSYSDEBUG
        frmDebug.Visible = Not frmDebug.Visible
    End Select
End Function
